import express from 'express';
import { promises as fs } from 'fs';
import { Client, Collection, Server } from '.';
// import serverSetup from '../api/server';

export default class ServerManagement {
  public client: Client;

  public servers: Collection<Server>;

  constructor(client: Client) {
    this.client = client;
    this.servers = new Collection<Server>();
    this.loadServers();
  }

  public async loadServers() {
    const apiRoot = await fs.readdir(`${__dirname}/../api`);
    for (const api of apiRoot) {
      // eslint-disable-next-line no-continue
      if (api === 'server.js') continue;
      const server: Server = require(`${__dirname}/../api/${api}/main.js`).default(this);
      this.servers.add(api, server);
      this.client.util.signale.success(`Successfully loaded server '${api}'.`);
    }
  }
}
